summaryrefslogtreecommitdiff
path: root/tests/factor/basic
diff options
context:
space:
mode:
Diffstat (limited to 'tests/factor/basic')
-rwxr-xr-xtests/factor/basic114
1 files changed, 114 insertions, 0 deletions
diff --git a/tests/factor/basic b/tests/factor/basic
new file mode 100755
index 0000000..8b91cce
--- /dev/null
+++ b/tests/factor/basic
@@ -0,0 +1,114 @@
+#!/bin/sh
+# -*-perl-*-
+# Basic tests for "factor".
+
+# Copyright (C) 1998, 1999, 2000, 2003, 2004, 2005 Free Software
+# Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+: ${PERL=perl}
+: ${srcdir=.}
+
+$PERL -e 1 > /dev/null 2>&1 || {
+ echo 1>&2 "$0: configure didn't find a usable version of Perl," \
+ "so can't run this test"
+ exit 77
+}
+
+d=$srcdir/..
+exec $PERL -w -I$d -MCoreutils -- - << \EOF
+require 5.003;
+use strict;
+
+(my $program_name = $0) =~ s|.*/||;
+
+# Turn off localisation of executable's ouput.
+@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my $prog = $ENV{PROG} || die "$0: \$PROG not specified in environment\n";
+
+my @Tests =
+ (
+ ['1', '9', {OUT => '3 3'}],
+ ['1a', '7', {OUT => '7'}],
+ ['2', '4294967291', {OUT => '4294967291'}],
+ ['3', '4294967292', {OUT => '2 2 3 3 7 11 31 151 331'}],
+ ['4', '4294967293', {OUT => '9241 464773'}],
+
+ ['a', '4294966201', {OUT => '12197 352133'}],
+ ['b', '4294966339', {OUT => '13187 325697'}],
+ ['c', '4294966631', {OUT => '13729 312839'}],
+ ['d', '4294966457', {OUT => '14891 288427'}],
+ ['e', '4294966759', {OUT => '21649 198391'}],
+ ['f', '4294966573', {OUT => '23071 186163'}],
+ ['g', '4294967101', {OUT => '23603 181967'}],
+ ['h', '4294966519', {OUT => '34583 124193'}],
+ ['i', '4294966561', {OUT => '36067 119083'}],
+ ['j', '4294966901', {OUT => '37747 113783'}],
+ ['k', '4294966691', {OUT => '39241 109451'}],
+ ['l', '4294966969', {OUT => '44201 97169'}],
+ ['m', '4294967099', {OUT => '44483 96553'}],
+ ['n', '4294966271', {OUT => '44617 96263'}],
+ ['o', '4294966789', {OUT => '50411 85199'}],
+ ['p', '4294966189', {OUT => '53197 80737'}],
+ ['q', '4294967213', {OUT => '57139 75167'}],
+ ['s', '4294967071', {OUT => '65521 65551'}],
+ ['t', '4294966194', {OUT => '2 3 3 3 3 3 3 3 53 97 191'}],
+ ['u', '4294966272', {OUT => '2 2 2 2 2 2 2 2 2 2 3 23 89 683'}],
+ ['v', '4294966400', {OUT => '2 2 2 2 2 2 2 5 5 1342177'}],
+ ['w', '4294966464', {OUT => '2 2 2 2 2 2 3 3 3 2485513'}],
+ ['x', '4294966896', {OUT => '2 2 2 2 3 3 3 11 607 1489'}],
+ ['y', '4294966998', {OUT => '2 3 7 3917 26107'}],
+ ['z', '-1',
+ {ERR => "$prog: invalid option -- 1\n"
+ . "Try `$prog --help' for more information.\n"},
+ {EXIT => 1}],
+ ['cont', 'a 4',
+ {OUT => "4: 2 2\n"},
+ {ERR => "$prog: `a' is not a valid positive integer\n"},
+ {EXIT => 1}],
+ );
+
+# Prepend the command line argument and append a newline to end
+# of each expected `OUT' string.
+my $t;
+
+Test:
+foreach $t (@Tests)
+ {
+ my $arg1 = $t->[1];
+
+ # Don't fiddle with expected OUT string if there's a nonzero exit status.
+ foreach my $e (@$t)
+ {
+ ref $e eq 'HASH' && exists $e->{EXIT} && $e->{EXIT}
+ and next Test;
+ }
+
+ foreach my $e (@$t)
+ {
+ ref $e eq 'HASH' && exists $e->{OUT}
+ and $e->{OUT} = "$arg1: $e->{OUT}\n"
+ }
+ }
+
+my $save_temps = $ENV{SAVE_TEMPS};
+my $verbose = $ENV{VERBOSE};
+
+my $fail = run_tests ($program_name, $prog, \@Tests, $save_temps, $verbose);
+exit $fail;
+EOF